.TH gen57pt G "March 2000" "Scilab Group" "Scilab Function"
.so ../sci.an
.SH NAME
gen57pt - generates 5-point and 7-point matrices
.SH CALLING SEQUENCE
.nf
[A,rhs]=gen57pt(nx,ny,nz,al,mod)
.fi
.SH PARAMETERS
.TP
nx
: number of grid points in x direction
.TP
ny
: number of grid points in y direction
.TP
nz
: number of grid points in z direction
.TP
al
: array of size 6, carries the coefficient alpha of the boundary conditions
.TP
mod
: what to generate,
.LP
<0 : generate the graph only,
.LP
 0 : generate the matrix,
.LP
>0 : generate the matrix and the right-hand side.
.TP
A
: resulting sparse matrix 
.TP
rhs
: the right-hand side
.SH DESCRIPTION
\fV[A,rhs]=gen57pt(nx,ny,nz,al,mod)\fR gives 5-pt and 7-pt matrices on rectangular regions
discretizing elliptic operators of the form: 
.LP
L u == delx( a delx u ) + dely ( b dely u) + delz ( c delz u ) + 
                delx ( d u ) + dely (e u) + delz( f u ) + g u = h u
.LP
with Boundary conditions:
.LP
alpha del u / del n + beta u = gamma
.LP
on a rectangular 1-D, 2-D or 3-D grid using centered difference scheme or upwind scheme.
.LP
The functions a, b, ..., h are known through the
subroutines  afun, bfun, ..., hfun in the file
functns.f. The alpha is a constant on each side of the
rectanglar domain. the beta and the gamma are defined
by the functions betfun and gamfun (see functns.f for
examples).
.SH EXAMPLE
nx=10;ny=10;nz=10;
al=zeros(1,6);
mod=0;
[A,rhs]=gen57pt(nx,ny,nz,al,mod)
.nf
.fi
.SH AUTHOR
Yousef Saad
.SH SEE ALSO
