.TH mminfo G "May 2000" "Scilab Group" "Scilab Function"
.so ../sci.an
.SH NAME
mminfo - reads the contents of the Matrix Market file 'filename' and extracts size and storage information.
.SH CALLING SEQUENCE
.nf
[rows, cols, entr, rep, typ, symm] = mminfo(file)
.fi
.SH PARAMETERS
.TP
file
: the name of the Matrix Market file
.TP
rows
: number of rows of the matrix
.TP
cols
: number of columns of the matrix
.TP
entr
: number of nonzero entries
.TP
rep
: representation of the Matrix Market format
.LP
  -'coordinate', coordinate sparse storage
.LP
  -'array', dense array storage
.TP
typ
: type of the entries: 'real', 'complex', 'integer', pattern'
.TP
symm
: give some informations about the symmetry of the matrix: 'general', 'symmetric', 'hermitian', 'skew-symmetric'
.SH DESCRIPTION
\fV[rows, cols, entr, rep, typ, symm] = mminfo(file)\fR reads the contents of the Matrix Market file 'file' and extracts size and storage information. In the case of coordinate matrices, entries refers to the number of coordinate entries stored in the file.  The number of non-zero entries in the final matrix cannot be determined until the data is read (and symmetrized, if necessary). In the case of array matrices, entries is the product rows*cols, regardless of whether symmetry was used to store the matrix efficiently.
//
.LP
.SH EXAMPLE
.nf
The file 'test.mtx' is obtained by downloading one of the matrix, stored in matrix market format, on the Matrix Market home page. 
[rows,cols,entr,rep,typ,symm] = mminfo('test.mtx')

.fi
.SH AUTHOR
Source given by the Matrix Market web site. Adaptations for Scilab done by Aladin team - 14 May 2001.
.SH SEE ALSO
mmread, mmwrite