.TH milu0 G "March 2000" "Scilab Group" "Scilab Function"
.so ../sci.an
.SH NAME
milu0 - MILU(0) preconditioning
.SH CALLING SEQUENCE
.nf
[L,U,ierr]=milu0(A)
.fi
.SH PARAMETERS
.TP
A
: sparse matrix (must be square)
.TP
L
: lower triangular matrix
.TP
U
: upper triangular matrix
.TP
ierr
: error flag
.SH DESCRIPTION
\fV[L,U,ierr]=milu0(A)\fR builds an incomplete LU factorization of the sparse matrix \fVA\fR. The two factors L and U are stored in the internal CSR format. The CSR format is the Compressed Sparse Row format used by Scilab. 
.TP 
ierr
: The error flag on return.
.LP
   0 --> normal return
.LP
   k --> code stoped on a zero pivot at step k.
.SH EXAMPLE
.nf
A=mmread(SCILIN+'/demos/matrices/nos3.mtx')
n=size(A,1); b=ones(n,1);
[L,U,ierr]=milu0(spa)
x=U\(L\b)
A*x-b
.fi
.SH AUTHOR
Aladin Group & Yousef Saad
.SH SEE ALSO
sparse