.TH split G "March 2000" "Scilab Group" "Scilab Function"
.so ../sci.an
.SH NAME
split -  matrix splitting for the stationary iterative methods: jacobi and sor
.SH CALLING SEQUENCE
.nf
[M,N,b] = split(A,b,w,flag)
.fi
.SH PARAMETERS
.TP
A
: matrix
.TP
b
: right hand side vector (for SOR)
.TP
w
: relaxation scalar; \fVw\fR uses the default, 0.4
.TP
flag
: 1 = jacobi, 2 = sor; \fVflag\fR uses the default, 1
.TP
M
: matrix
.TP
N
: matrix such that A = M - N
.TP
b
: rhs vector ( altered for SOR )
.SH DESCRIPTION
\fV[M,N,b] = split(A,b,w,flag)\fR sets up the matrix splitting for the stationary iterative methods: jacobi and sor (gauss-seidel when w = 1.0 )
.SH EXAMPLE
.nf
A=rand(4,4);b=rand(4,1);w=0.4;flag=1;
[M,N,b] = split(A,b,w,flag)
[M,N,b] = split(A,b)
.fi
.SH AUTHOR
Source given by the Univ. of Tennessee and Oak Ridge National Laboratory. Adaptations for Scilab done by Aladin team - 20 March 2001.
.SH SEE ALSO
